{$APPTYPE CONSOLE}

{$ifdef FPC}
  {$MODE DELPHI}
{$endif}

program RectangleWith;

uses
  Windows
  ;

{$ifdef VER90} { Delphi 2.0 }
  // definition missing in Delphi 2.0

  function GetConsoleWindow : HWND; stdcall; external 'kernel32';
{$endif}


var
  ConsoleWindow : HWND;
  OriginalConsoleRect : TRECT;

procedure DoIt;
const
  RectA              : TRECT = (Left:0; Top:0; Right:0; Bottom:0);
  RectB              : TRECT = (Left:0; Top:0; Right:0; Bottom:0);

var
  ClientRect    : TRECT;
  Width         : integer;
  Height        : integer;

begin

  // move and size the console window

  MoveWindow(ConsoleWindow, 50, 50, 400, 300, true);

  GetClientRect(ConsoleWindow, ClientRect);

  Width := ClientRect.Right  div 4;
  Height:= ClientRect.Bottom div 4;

  with RectA do
  begin
    Left   := (ClientRect.Right  - Width)  div 2;
    Top    := (ClientRect.Bottom - Height) div 2;
    Right  := Left + Width;
    Bottom := Top  + Height;
  end;
  CopyRect(RectB, RectA);

  // output the values in the rectangles

  writeln;
  writeln('Width  : ', Width);
  writeln('Height : ', Height);
  writeln;

  writeln('ClientRect : ');
  writeln('  (Top,    Left)  : ', ClientRect.Top   :4, '  ', ClientRect.Left:4);
  writeln('  (Bottom, Right) : ', ClientRect.Bottom:4, '  ', ClientRect.Right:4);

  writeln;
  writeln('RectA : ');
  writeln('  (Top,    Left)  : ', RectA.Top:4,    '  ', RectA.Left:4);
  writeln('  (Bottom, Right) : ', RectA.Bottom:4, '  ', RectA.Right:4);

  writeln;
  writeln('RectB : ');
  writeln('  (Top,    Left)  : ', RectB.Top:4,    '  ', RectB.Left:4);
  writeln('  (Bottom, Right) : ', RectB.Bottom:4, '  ', RectB.Right:4);

  writeln;
  writeln('Press <enter>/<return> to show results without using "with"');
  readln;

  RectA.Left   := (ClientRect.Right  - Width)  div 2;
  RectA.Top    := (ClientRect.Bottom - Height) div 2;
  RectA.Right  := RectA.Left + Width;
  RectA.Bottom := RectA.Top  + Height;
  CopyRect(RectB, RectA);

  // output the values in the rectangles again

  writeln;
  writeln('Width  : ', Width);
  writeln('Height : ', Height);
  writeln;

  writeln('ClientRect : ');
  writeln('  (Top,    Left)  : ', ClientRect.Top   :4, '  ', ClientRect.Left:4);
  writeln('  (Bottom, Right) : ', ClientRect.Bottom:4, '  ', ClientRect.Right:4);

  writeln;
  writeln('RectA : ');
  writeln('  (Top,    Left)  : ', RectA.Top:4,    '  ', RectA.Left:4);
  writeln('  (Bottom, Right) : ', RectA.Bottom:4, '  ', RectA.Right:4);

  writeln;
  writeln('RectB : ');
  writeln('  (Top,    Left)  : ', RectB.Top:4,    '  ', RectB.Left:4);
  writeln('  (Bottom, Right) : ', RectB.Bottom:4, '  ', RectB.Right:4);

end;

begin
  ConsoleWindow := GetConsoleWindow;

  // save the origin and size of the current console (this is just to make
  // the example unobtrusive

  GetWindowRect(ConsoleWindow, OriginalConsoleRect);


  DoIt;   // show the problem

  writeln;
  writeln('Press <enter>/<return> to end this program');
  readln;

  with OriginalConsoleRect do
  MoveWindow(ConsoleWindow,
             Left,
             Top,
             Right  - Left,
             Bottom - Top,
             true);
end.